<template>
  <el-form ref="pwdRef" :model="user" :rules="rules" label-width="80px">
    <el-form-item label="旧密码" prop="oldPassword">
      <el-input
        v-model="user.oldPassword"
        placeholder="请输入旧密码"
        type="password"
        show-password
      />
    </el-form-item>
    <el-form-item label="新密码" prop="newPassword">
      <el-input
        v-model="user.newPassword"
        placeholder="请输入新密码"
        type="password"
        show-password
      />
    </el-form-item>
    <el-form-item label="确认密码" prop="confirmPassword">
      <el-input
        v-model="user.confirmPassword"
        placeholder="请确认新密码"
        type="password"
        show-password
      />
    </el-form-item>
    <el-form-item>
      <el-button type="primary" @click="submit">保存</el-button>
      <el-button type="danger" @click="close">关闭</el-button>
    </el-form-item>
  </el-form>
</template>

<script setup>
import { updateUserPwd } from "@/api/system/user";
import { getPublicKey } from "@/api/login";
import { encrypt } from "@/utils/jsencrypt";
const { proxy } = getCurrentInstance();

const user = reactive({
  oldPassword: undefined,
  newPassword: undefined,
  confirmPassword: undefined,
});

const equalToPassword = (rule, value, callback) => {
  if (user.newPassword !== value) {
    callback(new Error("两次输入的密码不一致"));
  } else {
    callback();
  }
};
const rules = ref({
  oldPassword: [{ required: true, message: "旧密码不能为空", trigger: "blur" }],
  newPassword: [
    { required: true, trigger: "blur", validator: checkPassword },
    { min: 6, max: 20, message: "长度在 6 到 20 个字符", trigger: "blur" },
  ],
  confirmPassword: [
    { required: true, validator: checkPassword, trigger: "blur" },
    { required: true, validator: equalToPassword, trigger: "blur" },
  ],
});

function checkPassword(rule, value, callback) {
  this.level = [];
  if (!value) {
    return callback("密码不能为空");
  }
  if (value.length < 8) {
    return callback("密码不少于8位");
  }
  if (value.length > 20) {
    return callback("密码不大于20位");
  }
  // 校验是数字
  const regex1 = /^\d+$/;
  // 校验字母
  const regex2 = /^[A-Za-z]+$/;
  // 校验符号
  const regex3 =
    /^[`~!@#$%^&*()_\-+=<>?:"{}|,.\/;'\\[\]·~！@#￥%……&*（）——\-+={}|《》？：“”【】、；‘'，。、]+$/;
  if (regex1.test(value)) {
    this.level.push("low");
    return callback("设置8至20位包含大小写字母、数字、特殊符号的密码");
  } else if (regex2.test(value)) {
    this.level.push("low");
    return callback("设置8至20位包含大小写字母、数字、特殊符号的密码");
  } else if (regex3.test(value)) {
    this.level.push("low");
    return callback("设置8至20位包含大小写字母、数字、特殊符号的密码");
  } else if (/^[A-Za-z\d]+$/.test(value)) {
    this.level.push("low");
    this.level.push("middle");
    return callback("设置8至20位包含大小写字母、数字、特殊符号的密码");
  } else if (
    /^[`~!@#$%^&*()_\-+=<>?:"{}|,.\/;'\\[\]·~！@#￥%……&*（）——\-+={}|《》？：“”【】、；‘'，。、\d]+$/.test(
      value
    )
  ) {
    this.level.push("low");
    this.level.push("middle");
    return callback("设置8至20位包含大小写字母、数字、特殊符号的密码");
  } else if (
    /^[`~!@#$%^&*()_\-+=<>?:"{}|,.\/;'\\[\]·~！@#￥%……&*（）——\-+={}|《》？：“”【】、；‘'，。、A-Za-z]+$/.test(
      value
    )
  ) {
    this.level.push("low");
    this.level.push("middle");
    return callback("设置8至20位包含大小写字母、数字、特殊符号的密码");
  } else if (
    /^[`~!@#$%^&*()_\-+=<>?:"{}|,.\/;'\\[\]·~！@#￥%……&*（）——\-+={}|《》？：“”【】、；‘'，。、A-Za-z\d]+$/.test(
      value
    )
  ) {
    this.level.push("low");
    this.level.push("middle");
    this.level.push("high");
  }
  return callback();
}
function getPublicKey1() {
  return new Promise((resolve, reject) => {
    getPublicKey()
      .then((res) => {
        resolve(res);
      })
      .catch((error) => {
        reject(error);
      });
  });
}

/** 提交按钮 */
function submit() {
  proxy.$refs.pwdRef.validate((valid) => {
    if (valid) {
      getPublicKey().then((res) => {
        let publicKey = res.publicKey;
        const oldPassword = encrypt(user.oldPassword, publicKey);
        const newPassword = encrypt(user.newPassword, publicKey);
        updateUserPwd(oldPassword, newPassword).then((response) => {
          proxy.$modal.msgSuccess("修改成功");
          setTimeout(() => {
            location.href = "/";
          }, 200);
        });
      });
    }
  });
}
/** 关闭按钮 */
function close() {
  proxy.$tab.closePage();
}
</script>
